/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package alapOsztalyok;

public class Diak implements Comparable<Diak> {
    private String nev;
    private int pont;
    
    public enum Szempont {NEV_SZERINT, PONT_SZERINT}

    public static final int NOVEKVOEN = 1, CSOKKENOEN = -1;
    private static Szempont miSzerint;
    private static int miModon;

    /**
     * Konstruktor
     * @param nev
     * @param pont 
     */
    public Diak(String nev, int pont) {
        this.nev = nev;
        this.pont = pont;
    }

    @Override
    public String toString() {
        return nev + "  " + pont + " pont";
    }

    /**
     * A megadott szempont és a megadott mód szerint hasonlítja össze
     * a diákokat.
     * (A miModon szorzó előjelet változtathat, ezért a rendezés irányát is.)
     * @param d
     * @return 
     */
    @Override
    public int compareTo(Diak d) {
        switch(miSzerint){
            case NEV_SZERINT : {
                return miModon*(this.nev.compareTo(d.nev));                
            }
            case PONT_SZERINT :{
               return  miModon*(this.pont - d.pont);               
            }
            default:{
                return 0;
            }     
        }
    }

    // getterek
    public String getNev() {
        return nev;
    }

    public int getPont() {
        return pont;
    }

    public static Szempont getMiSzerint() {
        return miSzerint;
    }

    public static int getMiModon() {
        return miModon;
    }

    public static void setMiSzerint(Szempont miSzerint) {
        Diak.miSzerint = miSzerint;
    }

    public static void setMiModon(int miModon) {
        if(miModon == 1 || miModon == 2) Diak.miModon = miModon;
        else Diak.miModon = 0;
    }   
}
